# Telegram Shop Bot
Данный репозиторий содержит Telegram-бот, который является интернет-магазином. Он создан с использованием фреймворка Aiogram и обладает следующими функциями: продажа товаров онлайн, inline-меню, поддержка пользователей, отзывы, раздел вопросы-ответы, админ-панель для настройки параметров и база данных SQLite.

## Требования
Для запуска этого бота на локальной машине необходимо установить следующие зависимости:

- Python 3.7 или выше
- Все зависимости, перечисленные в файле requirements.txt

Вы можете установить необходимые зависимости, выполнив следующую команду:

```shell
pip install -r requirements.txt
```

## Конфигурация
Перед запуском бота вам необходимо предоставить необходимые настройки конфигурации. Файл конфигурации config.py должен быть заполнен необходимыми значениями. Обязательно обновите следующие настройки:

- 'BOT_TOKEN': Ваш токен API для Telegram-бота. Вы можете получить его, создав нового бота с помощью BotFather.
- Другие параметры конфигурации, такие как настройки базы данных, контакты администраторов и т.д, указаны в файле config.py.

## Использование
После установки зависимостей и заполнения настроек конфигурации вы можете запустить бота файлом main.py:

```shell
python main.py
```
Бот запущен. Но для бесперебойной работы лучше подойдет режим работы через демона, например, с помощью ``systemd`` на системах с ОС linux

## Функциональность
- **Онлайн-магазин**. Бот позволяет пользователям просматривать и покупать товары онлайн. Он предоставляет интуитивно понятный интерфейс с inline-меню, что облегчает пользователям навигацию и совершение покупок.

- **Поддержка пользователей**. Пользователи могут обратиться за поддержкой к администратору, задав вопросы

- **Отзывы**. Пользователи имеют возможность оставлять отзывы о товарах или общем опыте работы с ботом. Эта обратная связь помогает улучшить качество обслуживания и предоставляет ценную информацию как для администратора, так и для других пользователей.

- **Раздел вопросы-ответы**. Бот включает отдельный раздел для часто задаваемых вопросов (FAQ). Пользователи могут получить доступ к этому разделу, чтобы найти ответы на распространенные вопросы, не обращаясь в поддержку.

- **Админ-панель**. Для управления настройками и параметрами бота доступна админ-панель. Администраторы могут настраивать различные аспекты бота, такие как список товаров, ценообразование, варианты оплаты и многое другое.

- **База данных SQLite**. Бот использует базу данных SQLite для хранения и извлечения данных, обеспечивая целостность данных и эффективное управление ими.

- **И другое...**

## Лицензия
Этот проект лицензируется в соответствии с MIT License. Вы можете свободно использовать, изменять и распространять код в соответствии с условиями лицензии.
